--Preperation

use [RTOLTP-diskBased]

-----create table orders 
create table orders_filter (
AccountKey int not null,
customername nvarchar (50),
OrderNumber bigint,
PurchasePrice decimal (9,2),
OrderStatus smallint not NULL,
OrderStatusDesc nvarchar (50))

------ create clustered index on orderstatus

create clustered index orders_ci on orders(OrderStatus)


---- load 3.000.000 million records into table orders 
declare @outerloop int = 0
declare @i int = 0
declare @purchaseprice decimal (9,2)
declare @customername nvarchar (50)
declare @accountkey int
declare @orderstatus smallint
declare @orderstatusdesc nvarchar(50)
declare @ordernumber bigint
while (@outerloop < 3000000)

begin
Select @i = 0

begin tran
while (@i < 2000)

begin
set @ordernumber = @outerloop + @i
set @purchaseprice = rand() * 1000.0
set @accountkey = convert (int, RAND ()*1000)
set @orderstatus = convert (smallint, RAND()*60)
if (@orderstatus >= 5) set @orderstatus = 5

set @orderstatusdesc  =
case @orderstatus
WHEN 0 THEN  'Order Started'
WHEN 1 THEN  'Order Closed'
WHEN 2 THEN  'Order Paid'
WHEN 3 THEN 'Order Fullfillment'
WHEN 4 THEN  'Order Shipped'
WHEN 5 THEN 'Order Received'
END

insert  orders
values (@accountkey, (convert(varchar(6), @accountkey) + 'firstname'),@ordernumber, @purchaseprice,@orderstatus, @orderstatusdesc)

set @i += 1;
end
commit

set @outerloop = @outerloop + 2000
set @i = 0

end
go

-- START DEMO 
select count(*)
from orders

-- Create NCCI on orders
CREATE NONCLUSTERED COLUMNSTORE INDEX orders_ncci 
	ON orders (accountkey, customername, purchaseprice, orderstatus,
	 orderstatusdesc)  WITH (MAXDOP =1 )

-- Check the rowgroups
select object_name(object_id) as 'table', object_id, index_id, row_group_id, delta_store_hobt_id, state_desc, total_rows,  transition_to_compressed_state_desc
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders')

-- load another 1.000.000 orders with cursos to simulate OLTP workload (Orderstatus)

exec [Simulate OLTP]

-- show table orders with 4 million records
select count(*)
from orders

-- check rowgroups nonclusterd index 
select object_name(object_id), index_id, row_group_id, delta_store_hobt_id, state_desc, total_rows,  transition_to_compressed_state_desc
from sys.dm_db_column_store_row_group_physical_stats
where object_id = object_id('orders')

-- Run statistics 
set statistics time on
set statistics IO on

select sum(PurchasePrice) as 'Total', max(PurchasePrice) as 'Max', AVG(PurchasePrice) as 'Average'
from orders 
where OrderStatus = 5


-- Run statistics without NCCI

select sum(PurchasePrice) as 'Total', max(PurchasePrice) as 'Max', AVG(PurchasePrice) as 'Average'
from orders 
where OrderStatus = 5
option(IGNORE_NONCLUSTERED_COLUMNSTORE_INDEX)


--drop old index and create NCCI with filter 
----> workload on the hot data, NCCI has less maintenance
 
DROP INDEX orders.orders_ncci
CREATE NONCLUSTERED COLUMNSTORE INDEX orders_ncci
	 ON orders (accountkey, customername, purchaseprice, orderstatus, orderstatusdesc)
	 WHERE orderstatus = 5 WITH (MAXDOP =1 )

-- See row groups, delta group and 'HOT data'

select count(*) as 'total orders'
from orders

select object_name(object_id) as 'table', row_group_id, delta_store_hobt_id, state_desc, total_rows,  transition_to_compressed_state_desc
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders_filter')

select sum(total_rows) as 'total rows in rowsgroup' 
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders_filter')

-- Run statistics NCCI with filter

select sum(PurchasePrice) as 'Total'
	  , max(PurchasePrice) as 'Max', AVG(PurchasePrice) as 'Average'
from orders 
where OrderStatus = 5


-- Without where -> comination of NCCI & rowstore

select sum(PurchasePrice) as 'Total', max(PurchasePrice) as 'Max', AVG(PurchasePrice) as 'Average'
from orders 
