-- Preperation

USE [RTOLTP-inMemory]
GO

ALTER DATABASE [RTOLTP-inMemory] ADD FILEGROUP RTOLTP_Filegroup CONTAINS MEMORY_OPTIMIZED_DATA;
ALTER DATABASE [RTOLTP-inMemory] ADD FILE( NAME = RTOLTP_file, FILENAME = 'C:\Program Files\Microsoft SQL Server\MSSQL13.MSSQLSERVER\MSSQL\DATA\RTOLTP_file')
TO FILEGROUP RTOLTP_Filegroup;
-- Enable Query store
AlTER DATABASE [RTOLTP-inMemory] SET QUERY_STORE = ON;
ALTER DATABASE [RTOLTP-inMemory] SET compatibility_level = 130


-- create table
CREATE TABLE orders (
AccountKey int not null IDENTITY (1,1) PRIMARY KEY NONCLUSTERED ,
customername nvarchar (50),
OrderNumber bigint,
PurchasePrice decimal (9,2),
OrderStatus smallint not NULL,
OrderStatusDesc nvarchar (50),
INDEX order_hash HASH (OrderStatus) WITH (BUCKET_COUNT = 64),
)
 WITH (MEMORY_OPTIMIZED = ON);
GO



------ Load 3.000.000 rows into in-memory table

declare @outerloop int = 0
declare @i int = 0
declare @purchaseprice decimal (9,2)
declare @customername nvarchar (50)
declare @orderstatus smallint
declare @orderstatusdesc nvarchar(50)
declare @ordernumber bigint
while (@outerloop < 4000000)
begin
Select @i = 0
begin tran
while (@i < 2000)
begin
set @ordernumber = @outerloop + @i
set @purchaseprice = rand() * 1000.0
set @orderstatus = convert (smallint, RAND()*60)
set @orderstatusdesc =
case @orderstatus
WHEN 0 THEN 'Order Started'
WHEN 1 THEN 'Order Closed'
WHEN 2 THEN 'Order Paid'
WHEN 3 THEN 'Order Fullfillment'
WHEN 4 THEN 'Order Shipped'
WHEN 5 THEN 'Order Received'
END

insert orders 
values ( (convert(varchar(25), @ordernumber) + 'firstname'), @ordernumber, @purchaseprice, @orderstatus, @orderstatusdesc)

set @i += 1;
end
commit
set @outerloop = @outerloop + 2000
set @i = 0
end
go

--- START DEMO
select count(*)
from orders 

-- add CCI
ALTER TABLE orders ADD INDEX order_cci CLUSTERED COLUMNSTORE

-- See row groups 

select count(*) as 'total orders'
from orders

select object_name(object_id) as 'table', object_id, row_group_id, delta_store_hobt_id, state_desc, total_rows,  transition_to_compressed_state_desc
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders')

select sum(total_rows) as 'total rows in rowsgroup' 
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders')

-- Run statistics

set statistics time on
set statistics IO on

select sum(PurchasePrice) as 'Total', max(PurchasePrice) as 'Max', AVG(PurchasePrice) as 'Average'
from orders
where OrderStatus = 5

-- See row groups, delta group and tail
update orders 
set OrderStatus=5
where OrderStatus = 4

select object_name(object_id) as 'table', object_id, row_group_id, deleted_rows, delta_store_hobt_id, state_desc, total_rows,  transition_to_compressed_state_desc
from sys.dm_db_column_store_row_group_physical_stats  
where object_id = object_id('orders')
